################################
# WIRED BOTS
#
# commands($victim$msg);
#
#  desc: This sub decides whether a message is a command or not.
#	 It first grabs $victim and $msg.
#	 Then it opens the commands dir, checks the file names and sees
#	 if there is a match. 
#	 If it is a command, goto that command to recieve a reply.
#	 Otherwise, return with 'notcommand' and $command equal to 0.
#  recv: $victim$msg
# sends: $command,$reply
################################

sub commands {

#grab the vars from args..
	$victim = shift;
	$msg = shift;


#set everything to default..
	$reply = "";
	$command = 0;

#open the commands dir..
opendir(DIR, "./commands");
	#for each of the filess..
	foreach $file (
 	#sort them
  	sort(
   	#grep out '.' and '..'
    	grep(!/^\./,
     	#read the dir
      	readdir(DIR)))) {
  		
    		#remove file extension in name
		$file =~ s/\.(.*)//g;
   			
      			#if there still isn't a command
		if ($command == 0) {
   				#if the $msg starts with /$file, its a command
			if ($msg =~ /^\/$file/i) {
				$command = 1;
   				#get $reply from the commands sub
				$reply = &{$file}($victim,$msg);
			}
		}
	}
closedir(DIR);

#if $reply is still blank, must not be a command
if ($reply eq "") {
$reply = "notcommand";
}

#give back the boolean $command, and $reply.
return $command,$reply;

}

1;
