################################
# WIRED BOTS
#
# on_error();
#
#  desc: This sub is called when an error occurs while communicating w/ TOC.
#	 It grabs the default AIM vars
#	 Grabs the error number
#	 Translates that number, and prints result.
#  recv: AIM's default vars.
# sends: nothing.
################################


sub on_error {
  my ($self, $evt) = @_;
  my ($error, @stuff) = @{$evt->args()};
  #translate the number into plain english
  my $errstr = $evt->trans($error);
  
  #filter it for the good stuff
  $errstr =~ s/\$(\d+)/$stuff[$1]/ge;
  
  #print it to the DOS window
  print "ERROR: $errstr\n";
  #if the error is we're going too fast, sleep some.
  if ($errstr eq "A message has been dropped, you are exceeding the server speed limit") {
    sleep(dosleep(5,10));
    print "Compensated for Flood..\n\n";
  }
}

1;
