#!/usr/local/ActivePerl-5.6/bin/perl
#####/usr/bin/perl

#################################################################
# this is the perl server for the big brother flexbot 
# monitoring system
# writen by nick trienens, haha....  have fun

#load modules
#use IO::Socket::INET;
use IO::Select;
use IO::Socket qw(AF_INET INADDR_ANY inet_ntoa);
##################

###################################
#$single_stats = ("AddPlayer" , "RemovePlayer");
#$double_stats = ("kills","deaths","suicides","friendly_kills");
$number_of_bots = 0;


###################################
#varables used to track users######
$updates=1000;
$new_user=1;
$ip = $INADDR_ANY;
$last_full_msg = "<msg></msg>\n";
#don't change this port, unless you also change the flash code
$client_port = '4446';
#don't change this port, unless you also change 
#Big Brother FlexMonitor code to match
$statIn_port = 5441;
###################################

#########################################################
###declare servers                       ################
$main = new IO::Socket::INET (LocalHost => $ip,
                              LocalPort => $client_port,
                              Listen    => 5,
                              Proto     => 'tcp',
                              Reuse     => 1 ) || die $!;

$flexServ = new IO::Socket::INET (LocalHost => $ip,
                              LocalPort => $statIn_port,
                              Listen    => 1,
                              Proto     => 'tcp',
                              Reuse     => 1 ) || die $!;
#########################################################

###################################
######set the terminator to null ##
#unfortunatly flash requires chr(0) 
#as the terminating character #####
$old_sep = $/;
$old_sep_two = $\;
$zero = chr(0);
$/ = $zero;
$\ = $zero;
$| = 1;


###################################

#############################
# Initialise IO::Select #####
$handles = new IO::Select();
$handles->add($main);
$handles->add($flexServ);
#############################

print "\nListening for clients on: all ips on port: $client_port"; 
print "\nListening for a position feed on: all ips: $statIn_port\n";

%hash = ();
#@lastTen = ();


LISTEN: while (1) {
  ($pending) = IO::Select->select($handles, undef, undef, 60);
  foreach $sock (@$pending) {
    if ($sock == $main){
      $num++;
      my $newsock = $sock->accept();
      print "Got new connection: $num\n"; 
      $newsock->autoflush();
      $number{$newsock} = $num;
      $handles->add($newsock);
      $new_user =1;
      
    }elsif($sock == $flexServ){
      print "new stats client accepted\n";
      $msg = "<msg></msg>\n";
      $flexIn = $sock->accept();
      $flexIn->autoflush();
      $handles->add($flexIn);
    }else{
      if($sock == $flexIn){
	#read form FlexIn socket
	$/ = $old_sep;
	$buf = <$sock>;
	$/ = $zero;
	
      }else{
	#read from a client
	$buf = <$sock>;
      }
      if ($buf){
	if($sock != $flexIn){
	  #write to clients
	  #$/ = $old_sep;
	  #'$\ = $old_sep_two;
	  #print $hash{"bot1"} ."_\n"; 
	  chomp($buf);
	  #print "$buf";
	  if($new_user){
	    #print "dump hash";
	    $sock_msg = "<msg>";
	    foreach $stat (keys %hash){
	      if($stat =~ /^(.*?)_(.*)$/){
		$sock_msg .= "<Stat name=\"UpdatePlayerStat\" number=\"$1\" statname=\"$2\" statvalue=\"$hash{$stat}\" />";
	      }
	    }
	    $sock_msg .= "</msg>";
	    print $sock "$sock_msg\n\r$zero";
	    print FILE  "$sock_msg\n";
	    #print length($sock_msg);
	    #print "$buf\n";
	  }else{
	    #form a message of the last updates to send
	    open(FILE, ">> The.xml");
	    $sock_msg = "<msg>";
	    foreach $msg (@lastTen){
	      $sock_msg .= "$msg";
	      print FILE  "$sock_msg\n";
	      shift(@lastTen);
	    }
	    $sock_msg .= "</msg>";
	    undef(@lastTen);
	    print $sock "$sock_msg\n\r$zero";
	    print FILE  "$sock_msg\n";
	    close(FILE);
	    #print "$sock_msg\n\r>";
	  }
	  $\ = $zero;
	  $/ = $zero;
	}else{
	  #save the message to flash equal to the message from flexbot
	  $msg = $buf;
	  parse();
	  #print "new: $msg";
	}
      }else{
	print "Socket $number{$sock} is gone.\n"; 
	#$number{$sock} = -1;
	$handles->remove($sock);
	#$msg = "<msg></msg>\n";
	close($sock);
      }
    }
  }
}




#sub new_parse(){
#  if(unshift(@lastTen, $msg) > 10){
#    print "droping one\n";
#    shift(@lastTen);
#    print $#lastTen;
#  }
#  parse();
#}

    


sub parse(){
    if($msg =~ m!<Type>(.*)</Type><Number>(.*)</Number>!){
      if($1 =~ /AddPlayer/){
	$number_of_bots++;
	#print "bot added $2\n";
      }
      if($1 =~ /RemovePlayer/){
	$number_of_bots--;
	push(@lastTen, "<Stat name=\"RemovePlayer\" number=\"$2\" />");
      }
      #print "number_of_bots = $number_of_bots, $2\n";
    }
  
    if($msg =~ m!<Type>UpdatePlayerStat</Type><Number>(.*)</Number><StatName>(.*)</StatName><StatValue>(.*)</StatValue>!){
      $hash{"$1_$2"} = $3;
      push(@lastTen, "<Stat name=\"UpdatePlayerStat\" number=\"$1\" statname=\"$2\" statvalue=\"$3\" />");
      #print "got a Update Player stat: $1_$2 = $3\n";
    }
    if($msg =~ m!<Type>UpdateTeamStat</Type><Team>(.*)</Team><StatName>(.*)</StatName><StatValue>(.*)</StatValue>!){
      $hash{"$1_$2"} = $3;
      push(@lastTen, "<Stat name=\"UpdateTeamStat\" number=\"$1\" statname=\"$2\" statvalue=\"$3\" />");
      #print "got a Update Team stat: $1_$2 = $3\n";
    }
    if($msg =~ m!<Type>UpdatePlayerBehavior</Type><Number>(.*)</Number><Name>(.*)</Name>!){
      $hash{"$1_behavior"}= $2;
      push(@lastTen, "<Stat name=\"UpdatePlayerStat\" number=\"$1\" statname=\"Behavior\" statvalue=\"$2\" />");
      #print "got updated player:$1 behavior:$2\n";
    }
    if($msg =~ m!<Type>UpdatePlayerName</Type><Number>(.*)</Number><Name>(.*)</Name></Stat>!){
      $hash{"$1_name"}= $2;
      push(@lastTen, "<Stat name=\"UpdatePlayerStat\" number=\"$1\" statname=\"Name\" statvalue=\"$2\" />");
      #print "got new updated player:$1 name:$2\n";
    }
    if($msg =~ m!<Type>UpdatePlayerTeam</Type><Number>(.*)</Number><Name>(.*)</Name></Stat>!){
      $hash{"$1_team"}= $2;
      push(@lastTen, "<Stat name=\"UpdatePlayerStat\" number=\"$1\" statname=\"Team\" statvalue=\"$2\" />");
      #print "got new updated player:$1 team:$2\n";
    }
    while($#lastTen > 20){
      shift(@lastTen);
    }
  }     
